/***********************************************************************

  FinalMix: Application.cpp
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  0.9.0		Initial version
  0.9.1		No change
  0.9.2		MS Wave loader

***********************************************************************/

#include "generic.h"
#include "Application.h"
#include "Frame.h"
#include "Loaders.h"
#include "Devices.h"

IMPLEMENT_APP(Application)
	
	bool Application::OnInit() {
		LoadersRegister();
		DevicesRegister();
	
		SetVendorName("MD");
		SetAppName(FM_NAME);
		
		gParentFrame = new Frame(FM_NAME);
		gParentFrame->Show(true);
		SetTopWindow(gParentFrame);
		SetExitOnFrameDelete(true);
		
		return true;
	}
	
	int Application::OnExit() {
		return 0;
	}
