/***********************************************************************

  FinalMix: DeviceMM.h
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  0.9.2		Initial
  0.9.4		Complete rewrite, native threads instead of wxThread

**********************************************************************/

#include "Devices.h"
#include <wx/wx.h>

#if defined(__WXMSW__)

#ifndef _FM_DEVICEMM_H_
#define _FM_DEVICEMM_H_

#include <windows.h>
#include <mmsystem.h>

class MMDevice : public Device {
	public:
		MMDevice();
		virtual ~MMDevice();
	
		virtual wxString Name() const;
		
		static Device * RegisterDevice();
		
		virtual bool Init(const format_ex_t fmt, DeviceCallback & callback);
		virtual bool Play();
		virtual bool Pause();
		virtual bool Stop();
		virtual bool Done();
		
		virtual samples_t GetPosition();
		
		friend DWORD __stdcall play_thread(LPVOID data);
		friend DWORD __stdcall push_thread(LPVOID data);

	private:
		void done();

		DeviceCallback * cb;
		format_ex_t pfmt;
		
		HANDLE play;
		DWORD play_id;
		HANDLE push;
		DWORD push_id;

		HWAVEOUT handle;
		bool opened;
		bool playing;
		
		HANDLE buf_mutex;
		size_t buf_count;
		size_t buf_start;
		size_t buf_size;
		size_t latency;
		void * buf;
		void * tmpbuf;
		samples_t position;

		WAVEHDR * fragments;
};

#endif

#endif
