/***********************************************************************

  FinalMix: Devices.h
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  0.9.2		Initial

**********************************************************************/

#ifndef _FM_DEVICES_H_
#define _FM_DEVICES_H_

#include "generic.h"

class DeviceCallback {
	public:
		virtual samples_t OnBuffer(void * buf, const samples_t len, const samples_t pos, const format_ex_t & fmt) = 0;
};

class Device {
	public:
		virtual wxString Name() const = 0;
		
		virtual bool Init(const format_ex_t fmt, DeviceCallback & callback) = 0;
		virtual bool Play() = 0;
		virtual bool Pause() = 0;
		virtual bool Stop() = 0;
		virtual bool Done() = 0;
		
		virtual samples_t GetPosition() = 0;
};

void DevicesRegister();

#endif
