/***********************************************************************

  FinalMix: Frame.h
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  0.9.0		Initial version
  0.9.1		No change
  0.9.2		No change

***********************************************************************/

#ifndef _FM_DRAW_H_
#define _FM_DRAW_H_

#include <wx/brush.h>
#include <wx/pen.h>
#include <wx/dc.h>

class Draw {
	public:
		static void Init();
		
		static void Bevel(wxDC & dc, bool up, wxRect & r);
		
		static void Light(wxDC * dc, bool selected);
		static void Medium(wxDC * dc, bool selected);
		static void Dark(wxDC * dc, bool selected);
		static void Peak(wxDC * dc);
		static void XCursor(wxDC * dc);
		
		static wxBrush lightBrush[2];
		static wxBrush mediumBrush[2];
		static wxBrush darkBrush[2];
		static wxPen lightPen[2];
		static wxPen mediumPen[2];
		static wxPen darkPen[2];
		static wxPen peakPen;
		static wxPen xcursorPen;
	private:
		static bool inited;
};

#endif
