/***********************************************************************

  FinalMix: LoaderWAV.h
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  0.9.2		Initial

**********************************************************************/

#ifndef _FM_LOADERWAV_H_
#define _FM_LOADERWAV_H_

#include "Loaders.h"
#include <wx/wx.h>
#include <wx/list.h>
#include <wx/datetime.h>

typedef struct {
	off_t pos;
	off_t len;
} DataPos;

WX_DECLARE_LIST(DataPos, Datas);

class WAVLoader : public Loader {
	public:
		WAVLoader();
		virtual ~WAVLoader();
		
		static Loader * RegisterLoader();
		
		virtual wxString Name() const;
		
		virtual enum status_t Attach(wxFile * file, const wxString & name, const wxDateTime modtime);
		virtual track_t NumIntTracks() const;
		virtual const format_t * TrackFormat(const track_t itrack) const;
		virtual wxString FileName() const;
		virtual wxDateTime GetModTime() const;
		virtual length_t GetRawLength() const;
		
		virtual samples_t GetSamples(const track_t itrack, const samples_t pos, const samples_t len, void * data);
	private:
		void done();
	
		wxFile * cf;
		wxString fname;
		wxDateTime mod_time;
		format_t format;
		track_t tracks;
		Datas datas;
};

#endif
