/***********************************************************************

  FinalMix: Loaders.h
  by Martin Decky
  
  Redistribution of this file is permitted under the GNU Public License.

  0.9.2		Initial

**********************************************************************/

#ifndef _FM_LOADERS_H_
#define _FM_LOADERS_H_

#include "generic.h"
#include <wx/wx.h>
#include <wx/file.h>
#include <wx/datetime.h>

class Loader {
	public:
		virtual wxString Name() const = 0;
		
		virtual enum status_t Attach(wxFile * file, const wxString & name, const wxDateTime modtime) = 0;
		virtual track_t NumIntTracks() const = 0;
		virtual const format_t * TrackFormat(const track_t itrack) const = 0;
		virtual wxString FileName() const = 0;
		virtual wxDateTime GetModTime() const = 0;
		virtual length_t GetRawLength() const = 0;
		
		virtual samples_t GetSamples(const track_t itrack, const samples_t pos, const samples_t len, void * data) = 0;
};

void LoadersRegister();

#endif
